;
; vd64.asm - D64 virtual file system for IDE64 filemanager v0.01 preview
;
; Written by
;  Kajtar Zsolt <soci@c64.rulez.org>
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
;

C_FILE		= 20
C_ERR		= 21

		*=$d000

                jmp init
                jmp exit
                jmp list

                .text "VD64 V0.01 (C) 2004 SOCI/SINGULAR",0
;-------------------------------
init		stx $bb
		sty $bc
                sta $b7

		ldx #0
si		lda ize,x
                sta $840,x
                inx
                bpl si
                
                lda #14
                sta $b9
                lda #C_FILE
                sta $b8
                jsr open
		lda #15
                sta $b9
                lda #C_ERR
                sta $b8
                lda #0
                sta $b7
                jmp open
;-------------------------------
exit		lda #C_FILE
		jsr close
                lda #C_ERR
		jmp close
;-------------------------------
list		stx mem+1
		sty mem+2

                lda #18
                sta track
                lda #0
                sta sector
                sta blocks
                sta blocks+1
                jsr seekto
                
                ldx #C_FILE
                jsr chkin
                
                ldx #0
ny              jsr chrin
		cpx #0
                beq nxp
		cpx #18
                beq nxp
                clc
                adc blocks
                sta blocks
                bcc *+5
                inc blocks+1
                
nxp             jsr chrin
                jsr chrin
                jsr chrin
                inx
                cpx #36
                bcc ny
                bne ny
                
                
                lda #1
                jsr mem
                jsr mem
                lda #0
                jsr mem
                jsr mem
                lda #18
                jsr mem
                lda #34
                jsr mem

		ldx #16
nu              jsr chrin
                jsr mem
                dex
                bne nu
                
                jsr chrin
                jsr chrin

                lda #34
                jsr mem
                lda #32
                jsr mem
                
		ldx #5
nu2             jsr chrin
                jsr mem
                dex
                bne nu2
                txa
                jsr mem
                
                lda #18
                sta track
                lda #1
                sta sector
more            jsr seekto
                ldx #C_FILE
                jsr chkin
                
                lda #8
                sta db
                
loop            lda db
                cmp #8
                bcc nx
                jsr chrin
                sta track
                jsr chrin
                sta sector
                jmp nx2

nx              jsr chrin
                jsr chrin
                
nx2             jsr chrin
                sta type

                jsr chrin
                jsr chrin

		ldx #16
li              jsr chrin
                sta name,x
                dex
                bne li
                
		ldx #9
li2             jsr chrin
                dex
                bne li2
                
                jsr chrin
                sta size
                jsr chrin
                sta size+1
                
                lda type
                and #$8f
                beq del
                
                lda #1
                jsr mem
                jsr mem
                lda size
                jsr mem
                lda size+1
                jsr mem
                
                lda #34
                jsr mem
                ldx #16
ri              lda name,x
                cmp #$a0
                beq ni
                jsr mem
                dex
                bpl ri

ni              lda #34
                jsr mem
                
ri2             dex
		bmi cy
		lda name,x
                and #$7f
                jsr mem
                jmp ri2
cy
		lda #32
		ldx type
                bmi *+4
                lda #"*"
                jsr mem
                
                txa
                and #15
                tax
                
                lda t1,x
                jsr mem
                lda t2,x
                jsr mem
                lda t3,x
                jsr mem
                
                lda type
                asl
                asl
                lda #32
                bcc *+4
                lda #"<"
                jsr mem
                
                lda #32
                ldx #4
nup             jsr mem
                dex
                bne nup
                txa
                jsr mem
del             
                dec db
                bne loop

                jsr clrchn
                
                lda track
                bne more

		ldx #0
yi              lda bf,x
                jsr mem
                inx
                cpx #32
                bcc yi

		ldx mem+1
                ldy mem+2
                lda #$40
                sta $90
                clc
                rts
                
db		.byte 16

bf              .byte 1,1
blocks		.word 0
		.text "BLOCKS FREE.             ",0,0,0
type		.byte 0
name		.byte $a0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
size		.word 0
t1      	.byte "DSPUR"
t2      	.byte "EERSE"
t3              .byte "LQGRL"
		.byte $08,0,0,$3f,$7f,$3f,$7f,$11,$12,$13,$15
;--------------------                
seekto		ldx #C_ERR
                jsr chkout
                lda #"P"
                jsr chrout
                lda #14
                jsr chrout
                lda #$00
                jsr chrout
		ldx track
		lda addrlo-1,x
                clc
                adc sector
		php
                jsr chrout
                plp
                lda addrhi-1,x
                adc #0
                jsr chrout
                lda #$00
                jsr chrout
                jmp clrchn
;--------------------
mem             sta $ffff
                inc mem+1
                bne *+5
                inc mem+2
                rts
                
addrlo          .byte <(21*0)		;1
                .byte <(21*1)		;2
                .byte <(21*2)		;3
                .byte <(21*3)		;4
                .byte <(21*4)		;5
                .byte <(21*5)		;6
                .byte <(21*6)		;7
                .byte <(21*7)		;8
                .byte <(21*8)		;9
                .byte <(21*9)		;10
                .byte <(21*10)		;11
                .byte <(21*11)		;12
                .byte <(21*12)		;13
                .byte <(21*13)		;14
                .byte <(21*14)		;15
                .byte <(21*15)		;16
                .byte <(21*16)		;17
                .byte <(21*17)		;18
                .byte <(21*17+19*1)	;19
                .byte <(21*17+19*2)	;20
                .byte <(21*17+19*3)	;21
                .byte <(21*17+19*4)	;22
                .byte <(21*17+19*5)	;23
                .byte <(21*17+19*6)	;24
                .byte <(21*17+19*7)	;25
                .byte <(21*17+19*7+18*1)   ;26
                .byte <(21*17+19*7+18*2)   ;27
                .byte <(21*17+19*7+18*3)   ;28
                .byte <(21*17+19*7+18*4)   ;29
                .byte <(21*17+19*7+18*5)   ;30
                .byte <(21*17+19*7+18*6)   ;31
                .byte <(21*17+19*7+18*6+17*1);32
                .byte <(21*17+19*7+18*6+17*2);33
                .byte <(21*17+19*7+18*6+17*3);34
                .byte <(21*17+19*7+18*6+17*4);35
                .byte <(21*17+19*7+18*6+17*5);36
                .byte <(21*17+19*7+18*6+17*6);37
                .byte <(21*17+19*7+18*6+17*7);38
                .byte <(21*17+19*7+18*6+17*8);39
                .byte <(21*17+19*7+18*6+17*9);40

addrhi          .byte >(21*0)		;1
                .byte >(21*1)		;2
                .byte >(21*2)		;3
                .byte >(21*3)		;4
                .byte >(21*4)		;5
                .byte >(21*5)		;6
                .byte >(21*6)		;7
                .byte >(21*7)		;8
                .byte >(21*8)		;9
                .byte >(21*9)		;10
                .byte >(21*10)		;11
                .byte >(21*11)		;12
                .byte >(21*12)		;13
                .byte >(21*13)		;14
                .byte >(21*14)		;15
                .byte >(21*15)		;16
                .byte >(21*16)		;17
                .byte >(21*17)		;18
                .byte >(21*17+19*1)	;19
                .byte >(21*17+19*2)	;20
                .byte >(21*17+19*3)	;21
                .byte >(21*17+19*4)	;22
                .byte >(21*17+19*5)	;23
                .byte >(21*17+19*6)	;24
                .byte >(21*17+19*7)	;25
                .byte >(21*17+19*7+18*1)   ;26
                .byte >(21*17+19*7+18*2)   ;27
                .byte >(21*17+19*7+18*3)   ;28
                .byte >(21*17+19*7+18*4)   ;29
                .byte >(21*17+19*7+18*5)   ;30
                .byte >(21*17+19*7+18*6)   ;31
                .byte >(21*17+19*7+18*6+17*1);32
                .byte >(21*17+19*7+18*6+17*2);33
                .byte >(21*17+19*7+18*6+17*3);34
                .byte >(21*17+19*7+18*6+17*4);35
                .byte >(21*17+19*7+18*6+17*5);36
                .byte >(21*17+19*7+18*6+17*6);37
                .byte >(21*17+19*7+18*6+17*7);38
                .byte >(21*17+19*7+18*6+17*8);39
                .byte >(21*17+19*7+18*6+17*9);40
                
track		.byte 0
sector		.byte 0

ize                
                .logical $840
open		dec $1
		jsr $ffc0
                sei
                inc $1
                rts
close		dec $1
		jsr $ffc3
                sei
                inc $1
                rts
chkin		dec $1
		jsr $ffc6
                sei
                inc $1
                rts
chkout		dec $1
		jsr $ffc9
                sei
                inc $1
                rts
clrchn		dec $1
		jsr $ffcc
                sei
                inc $1
                rts
chrin		dec $1
		jsr $ffcf
                sei
                inc $1
                rts
chrout  	dec $1
		jsr $ffd2
                sei
                inc $1
                rts
                .here
